#include <fstream>
#include <vector>
using namespace std;

ifstream fin("lumina.in");
ofstream fout("lumina.out");

vector<int> convertToArray(string sir){
    vector<int> res;

    for(const auto &p : sir)
        res.push_back(p - '0');

    return res;
}
void computeXor(vector<int> &A, string B){
    int ind = 0;

    for(auto &p : A)
        p = p ^ (B[ind++] - '0');
}

bool checkSolution(vector<int> sir, int L, int M){
    int pos = 0, op = 0;

    while(pos < sir.size()){
        if(sir[pos] == 0)
            op++, pos += L;
        else pos++;

        if(op > M)
            return false;
    }
    return true;
}

int main() {
    int N, P, M;

    fin >> N >> P >> M;

    string A;
    fin >> A;
    vector <int> res;
    res = convertToArray(A);
   
    for(int i = 1; i < N; ++i){
        string B;

        fin >> B;

        computeXor(res, B);
    }
    
    int ans = -1;

    for(int i = P; i >= 0; --i)
        if(checkSolution(res, i, M))
            ans = i;
        
    fout << ans;
}